# encoding: utf-8
require_relative "./lib/nonoengine"
require_relative "./resources"
require_relative "./gameobject"
require_relative "./level"
require_relative "./mainmenu"

class NMTR
  attr_accessor :time, :story, :should_quit, :menu, :statistics

  def initialize
    $game = self
    Engine[Params::Width] = SCREENX
    Engine[Params::Height] = SCREENY
    Engine[Params::ClearColor] = Engine::Colors.new(100, 100, 100, 255)
    Engine::init "resources"
    Engine[Params::Volume] = 50
    RES::Splash.draw(SCREENX / 2, SCREENY / 2)
    Engine::process
    sleep 2
    @menu = MainMenu.new
    @story = Story.new
    @should_quit = false
    @time = 0
    @catching_esc = false
    @statistics = Hash.new(0)
  end

  def update
    if @menu.active
      @menu.update
    else
      @catching_esc = true if Engine::Key[KEY_ESCAPE] == :up
      if Engine::Key[KEY_ESCAPE] != :up && @catching_esc
        @menu.active = true
        @catching_esc = false
      end
      @story.update
      @story.level.update if @story.action

      #TODO if game.time > 19*60

      #@level = GameLevel.new(level.gen) if Engine::Key[KEY_K] == :pressed
    end
  end

  def draw
    @story.level.draw if @story.level
    @story.draw
    @menu.draw if @menu.active
  end
end

game = NMTR.new
loop do
  game.update
  game.draw
  Engine::process
  game.time += Engine[Params::DeltaTime] / 1000.0 unless game.menu.active
  break if Engine::Key[QUIT] != :up || game.should_quit
end
