
class DanceSkill < Skill
  attr_accessor :delay, :active

  def initialize(*args)
    super
    @delay = 0
    @active = false
  end

  def progress
    1.0 - 1.0 * @delay / @stats[:delay]
  end

  def update
    if @active
      angle = @start + @start_sign * 4 * Math::PI * @delay / @stats[:delay]
      @owner.body.apply_impulse(vec2(Math.cos(angle), Math.sin(angle)) * @stats[:force], vec2(0, 0))
      @delay += 1
      if @delay > @stats[:delay]
        @owner.dancing = nil
        @active = false
      end
    else
      @delay -= 1 if @delay > 0
    end
  end

  def ignore(enemy)
    false
  end

  def apply(dx, dy, btn_state)
    return if @delay > 0
    @active = true
    @start = rand * 2 * Math::PI
    @start_sign = rand < 0.5 ? -1.0 : 1.0
    @owner.dancing = @stats
  end
end
