
HEALER_BOMB = {
  desc: "Живой огонь",
  class: ShootSkill,
  picture: PROJ_STONES,
  maxrange: 200,
  speed: 500,
  spread: 0.2,
  count: 1,
  delay: 50,
  damage: 0,
  hud: 11 * 8 + 2,
  #sound: RES::Skills::Shot_fire,
  explode: {
    picture: PROJ_FIRE,
    maxrange: 25,
    speed: 500,
    spread: 2 * Math::PI,
    count: 16,
    delay: 10,
    damage: 1,
    pierce: 3,
    sound: RES::Skills::Explode,
  },
}

class HealSkill < Skill
  def initialize(*args)
    super
    @delay = 0
    @active = false
  end

  def progress
    1.0 - 1.0 * @delay / @stats[:delay]
  end

  def update
    if @active
      @owner.hp += 0.1
      @owner.pain += 0.2
      if @owner.hp >= @stats[:min] * PLAYER_HP || @owner.pain > @owner.hp
        @active = false
        @delay = @stats[:delay]
      end
    else
      @delay -= 1 if @delay > 0
    end
  end

  def apply(dx, dy, btn_state)
    return if @delay > 0 || @owner.hp >= @stats[:min] * PLAYER_HP
    @stats[:sound].play if @stats[:sound]
    @active = true
  end
end

HEALER_HEAL = {
  desc: "Самолечение",
  class: HealSkill,
  delay: 500,
  min: 1.0,
  hud: 12 * 8 + 2,
  sound: RES::Skills::Blessing,
}

HEALER =
  {
    name: "Хилер",
    desc: "чувствует чужую боль",
    material: MAT_PLAYER,
    picture: 13 * 8 + 2,

    left_skill: HEALER_BOMB,
    right_skill: HEALER_HEAL,
    passive: {
      class: Empathy,
      level: 0.075,
    },
  }
