MAT_ENEMY =
  {
    mass: 2.0,
    inertia: 1.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 400.0,
    leash_force: 4000.0,
  }

ORC_MELEE = {
  picture: 6 * 8 + 0,
  hp: 10,
  optimal_range: 0.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_SLASH,
    maxrange: 10,
    speed: 200,
    spread: 0.6,
    count: 1,
    delay: 50,
    damage: 1,
    force: 10.0,
    sound: RES::Skills::Sword,
  },
  material: MAT_ENEMY,
}

ORC_MELEE2 = {
  picture: 6 * 8 + 1,
  hp: 10,
  optimal_range: 0.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_SLASH,
    maxrange: 15,
    speed: 300,
    spread: 0.8,
    count: 1,
    delay: 75,
    damage: 1,
    block: true,
    force: 10.0,
    sound: RES::Skills::Melee,
  },
  material: MAT_ENEMY,
}

ORC_SHOOTER = {
  picture: 6 * 8 + 3,
  hp: 10,
  optimal_range: 300.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_STONES,
    maxrange: 500,
    speed: 400,
    spread: 0.2,
    count: 1,
    delay: 100,
    damage: 0.5,
    hitsound: RES::Skills::Crossbow,
    explode: {
      picture: PROJ_ACID,
      maxrange: 5,
      speed: 500,
      spread: 2 * Math::PI,
      count: 5,
      delay: 10,
      damage: 0.5,
      sound: RES::Skills::Explode,
    },
  },
  material: MAT_ENEMY,
}

GOBLIN_ARCHER = {
  picture: 6 * 8 + 4,
  hp: 5,
  optimal_range: 200.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_STONES,
    maxrange: 500,
    speed: 600,
    spread: 0.2,
    count: 1,
    delay: 40,
    damage: 2,
    hitsound: RES::Skills::Crossbow,
  },
  material: {
    mass: 2.0,
    inertia: 1.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 100.0,
    leash_force: 4000.0,
  },
}

DEMON_MELEE = {
  picture: 6 * 8 + 5,
  hp: 20,
  optimal_range: 0.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_SLASH,
    maxrange: 10,
    speed: 200,
    spread: 0.6,
    count: 1,
    delay: 60,
    damage: 1,
    force: 300.0,
    sound: RES::Skills::Amelee,
  },
  material: {
    mass: 4.0,
    inertia: 4.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 400.0,
    leash_force: 4000.0,
  },
}

DEMON_ARCHER = {
  picture: 6 * 8 + 7,
  hp: 20,
  optimal_range: 0.0,

  skill: {
    class: ShootSkill,
    picture: PROJ_DARK,
    maxrange: 200,
    speed: 700,
    spread: 0.6,
    count: 2,
    delay: 60,
    damage: 0.5,
    hitsound: RES::Skills::Crossbow,
  },
  material: {
    mass: 4.0,
    inertia: 4.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 100.0,
    leash_force: 1000.0,
  },
}

SPIDER = {
  pictures: [7 * 8 + 0, 7 * 8 + 1, 7 * 8 + 2, 7 * 8 + 3],
  hp: 5,
  optimal_range: 0.0,
  temporary: true,

  skill: {
    class: ShootSkill,
    picture: PROJ_POISON,
    maxrange: 10,
    speed: 200,
    spread: 0.1,
    count: 1,
    delay: 25,
    damage: 0.3,
    force: 0.0,
    sound: RES::Skills::Water,
  },
  material: {
    mass: 1.0,
    inertia: 0.5,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 300.0,
    leash_force: 4000.0,
  },
}

class SummonSkill < Skill
  def initialize(*args)
    super
    @delay = 0
  end

  def maxdistance
    1000 / 1.5
  end

  def apply(dx, dy, btn_state)
    return if @delay > 0
    @delay = stats[:delay]
    stats[:count].times do
      x = owner.x + rand - 0.5
      y = owner.y + rand - 0.5
      enemy = Enemy.new(stats[:list].sample)
      enemy.warp(x, y)
      $app.objects << enemy
    end
  end

  def progress
    1.0 - 1.0 * @delay / @stats[:delay]
  end

  def update
    @delay -= 1 if @delay > 0
  end
end

ORC_SUMMONER = {
  picture: 6 * 8 + 2,
  hp: 20,
  optimal_range: 1000.0,

  skill: {
    class: SummonSkill,
    delay: 4 * 60,
    list: [SPIDER],
    count: 4,
  },
  material: MAT_ENEMY,
}

DEMON_SUMMONER = {
  picture: 6 * 8 + 6,
  hp: 50,
  optimal_range: 1000.0,

  skill: {
    class: SummonSkill,
    delay: 10 * 60,
    list: [DEMON_MELEE],
    count: 2,
  },
  material: MAT_ENEMY,
}

ENEMY_SUPERBOSS = {
  picture: TILE_DEMON1,
  hp: 500,
  optimal_range: 100.0,
  boss: true,
  fixed_hp: true,
  big: true,

  skill: {
    sound: RES::Skills::Traphit,
    class: ShootSkill,
    picture: PROJ_POISON,
    maxrange: 500,
    speed: 800,
    spread: 1.0,
    count: 16,
    delay: 75,
    damage: 1,
    name: "superboss",
  },
  material: MAT_ENEMY,
}

ENEMY_CIVILIAN = {
  picture: TILE_DEMON1,
  hp: 100,
  optimal_range: 0.0,
  big: true,

  skill: {
    sound: RES::Skills::Traphit,
    class: ShootSkill,
    picture: PROJ_POISON,
    maxrange: 100,
    speed: 600,
    spread: 1.0,
    count: 16,
    delay: 75,
    damage: 0.3,
    name: "superboss",
  },
  material: MAT_ENEMY,
}

ENEMY_CIVILIAN2 = {
  picture: TILE_DEMON1,
  hp: 100,
  optimal_range: 300.0,
  big: true,

  skill: {
    class: SummonSkill,
    delay: 10 * 60,
    list: [DEMON_MELEE, ORC_MELEE, ORC_SHOOTER, GOBLIN_ARCHER, ORC_MELEE2],
    count: 4,
  },
  material: MAT_ENEMY,
}

HOUSE_MONSTERS = [ORC_MELEE, ORC_MELEE2, ORC_MELEE, ORC_MELEE2, ORC_MELEE, ORC_MELEE2, GOBLIN_ARCHER]
TOWN_MONSTERS = [ORC_SHOOTER, DEMON_MELEE, ORC_MELEE, DEMON_MELEE, ORC_SUMMONER]
CASTLE_MONSTERS = [DEMON_MELEE, ORC_MELEE, DEMON_ARCHER, DEMON_SUMMONER]
PORTAL_MONSTERS = [ENEMY_CIVILIAN, ENEMY_CIVILIAN, ENEMY_CIVILIAN, ENEMY_CIVILIAN2]

def gen_monster(difficulty)
  case difficulty
  when 0
    list = HOUSE_MONSTERS
  when 1
    list = TOWN_MONSTERS + HOUSE_MONSTERS
  when 2
    list = CASTLE_MONSTERS + TOWN_MONSTERS + HOUSE_MONSTERS
    list.reject! { |x| x == ORC_SUMMONER }
  when 3
    list = PORTAL_MONSTERS
  end
  list.sample
end
